//
// Created by 14782 on 2019/7/29.
//
#include <jni.h>
#include <string>
#include "ivr4pengine.h"
#include <EGL/egl.h>
#include <EGL/eglext.h>
#include <GLES2/gl2.h>

extern ANativeWindow * g_pVR4PNativeWindow;
extern EGLDisplay      g_mVR4PEglDisplay;
extern EGLSurface      g_mVR4PEglSurface;
extern EGLContext      g_mVR4PEglContext;

int  iWidth = 1920;
int  iHeight = 1080;

bool    InitContext(bool bUseFrontBuffer, bool bUseMutable)
{
    if(bUseFrontBuffer)
    {
        g_mVR4PEglDisplay = eglGetDisplay(EGL_DEFAULT_DISPLAY);
        if (EGL_FALSE == eglInitialize(g_mVR4PEglDisplay, 0, 0))
            return false;

        EGLConfig  mEglConfigMain;
        EGLint numConfigs = 0;

        const EGLint attribs[] =
                {
                        EGL_RENDERABLE_TYPE, EGL_OPENGL_ES2_BIT,
                        EGL_SURFACE_TYPE, bUseMutable?(EGL_WINDOW_BIT|EGL_MUTABLE_RENDER_BUFFER_BIT_KHR):EGL_WINDOW_BIT,
                        EGL_BLUE_SIZE,    8,
                        EGL_GREEN_SIZE,   8,
                        EGL_RED_SIZE,     8,
                        EGL_ALPHA_SIZE,   8,
                        EGL_DEPTH_SIZE,	0,
                        EGL_STENCIL_SIZE,	8,
                        EGL_SAMPLES,		0,
                        EGL_SAMPLE_BUFFERS,0,
                        EGL_NONE
                };

        eglChooseConfig(g_mVR4PEglDisplay, attribs, &mEglConfigMain, 1, &numConfigs);

        static const EGLint surf_attribute_list[] = {
                EGL_RENDER_BUFFER, EGL_SINGLE_BUFFER,
                EGL_NONE
        };

        g_mVR4PEglSurface = eglCreateWindowSurface(g_mVR4PEglDisplay, mEglConfigMain, g_pVR4PNativeWindow, surf_attribute_list);
        if (g_mVR4PEglSurface == EGL_NO_SURFACE)
            return false;

        eglSurfaceAttrib(g_mVR4PEglDisplay,g_mVR4PEglSurface,EGL_SWAP_BEHAVIOR,EGL_BUFFER_DESTROYED);

        EGLint attribList2[] = { EGL_CONTEXT_CLIENT_VERSION, 2, EGL_CONTEXT_PRIORITY_LEVEL_IMG,EGL_CONTEXT_PRIORITY_HIGH_IMG, EGL_NONE };

        g_mVR4PEglContext = eglCreateContext(g_mVR4PEglDisplay, mEglConfigMain, NULL, attribList2);
        if (g_mVR4PEglContext == EGL_NO_CONTEXT)
            return false;

        if (EGL_FALSE == eglMakeCurrent(g_mVR4PEglDisplay, g_mVR4PEglSurface, g_mVR4PEglSurface, g_mVR4PEglContext))
            return false;

        V4_ResetGLTexUpdatePT2((int64_t) g_mVR4PEglContext);

        eglQuerySurface(g_mVR4PEglDisplay, g_mVR4PEglSurface, EGL_WIDTH, &iWidth);
        eglQuerySurface(g_mVR4PEglDisplay, g_mVR4PEglSurface, EGL_HEIGHT, &iHeight);

        glBindFramebuffer(GL_FRAMEBUFFER, 0);
        glViewport(0,0,iWidth,iHeight);
        glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
        glClearStencil(0);
        glClear(GL_COLOR_BUFFER_BIT|GL_STENCIL_BUFFER_BIT);

        V4_ResizeMyGL(iWidth,iHeight);
        V4_ResetGLRes();

        return true;
    }
    else
    {
        g_mVR4PEglDisplay = eglGetDisplay(EGL_DEFAULT_DISPLAY);
        if (EGL_FALSE == eglInitialize(g_mVR4PEglDisplay, 0, 0))
            return false;

        EGLConfig  mEglConfigMain;
        EGLint numConfigs = 0;

        const EGLint attribs[] =
                {
                        EGL_RENDERABLE_TYPE, EGL_OPENGL_ES2_BIT,
                        EGL_SURFACE_TYPE, EGL_WINDOW_BIT,
                        EGL_BLUE_SIZE,    8,
                        EGL_GREEN_SIZE,   8,
                        EGL_RED_SIZE,     8,
                        EGL_ALPHA_SIZE,   8,
                        EGL_DEPTH_SIZE,	0,
                        EGL_STENCIL_SIZE,	8,
                        EGL_SAMPLES,		0,
                        EGL_NONE
                };

        eglChooseConfig(g_mVR4PEglDisplay, attribs, &mEglConfigMain, 1, &numConfigs);

        g_mVR4PEglSurface = eglCreateWindowSurface(g_mVR4PEglDisplay, mEglConfigMain, g_pVR4PNativeWindow, NULL);
        if (g_mVR4PEglSurface == EGL_NO_SURFACE)
            return false;

        eglSurfaceAttrib(g_mVR4PEglDisplay,g_mVR4PEglSurface,EGL_SWAP_BEHAVIOR,EGL_BUFFER_DESTROYED);

        EGLint attribList2[] = { EGL_CONTEXT_CLIENT_VERSION, 2,EGL_CONTEXT_PRIORITY_LEVEL_IMG,EGL_CONTEXT_PRIORITY_HIGH_IMG, EGL_NONE };

        g_mVR4PEglContext = eglCreateContext(g_mVR4PEglDisplay, mEglConfigMain, NULL, attribList2);
        if (g_mVR4PEglContext == EGL_NO_CONTEXT)
            return false;

        if (EGL_FALSE == eglMakeCurrent(g_mVR4PEglDisplay, g_mVR4PEglSurface, g_mVR4PEglSurface, g_mVR4PEglContext))
            return false;

        eglQuerySurface(g_mVR4PEglDisplay, g_mVR4PEglSurface, EGL_WIDTH, &iWidth);
        eglQuerySurface(g_mVR4PEglDisplay, g_mVR4PEglSurface, EGL_HEIGHT, &iHeight);

        glBindFramebuffer(GL_FRAMEBUFFER, 0);
        glViewport(0,0,iWidth,iHeight);
        glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
        glClearStencil(0);
        glClear(GL_COLOR_BUFFER_BIT|GL_STENCIL_BUFFER_BIT);

        V4_ResizeMyGL(iWidth,iHeight);
        V4_ResetGLRes();

        return true;
    }
}


void    UninitContext(bool bUseFrontBuffer)
{
    V4_ReleaseGLRes();

    if(bUseFrontBuffer)
        V4_ReleaseGLTexUpdatePT();

    if(g_mVR4PEglDisplay != NULL && g_mVR4PEglContext != EGL_NO_CONTEXT)
    {
        eglMakeCurrent(g_mVR4PEglDisplay, EGL_NO_SURFACE, EGL_NO_SURFACE, EGL_NO_CONTEXT);
        eglDestroyContext(g_mVR4PEglDisplay,g_mVR4PEglContext);
        g_mVR4PEglContext = EGL_NO_CONTEXT;
    }

    if(g_mVR4PEglDisplay != NULL && g_mVR4PEglSurface != EGL_NO_SURFACE)
    {
        eglDestroySurface(g_mVR4PEglDisplay,g_mVR4PEglSurface);
        g_mVR4PEglSurface = EGL_NO_CONTEXT;
    }

    if(g_mVR4PEglDisplay != NULL)
    {
        eglTerminate(g_mVR4PEglDisplay);
        g_mVR4PEglDisplay = NULL;
    }
}
